#!/bin/bash

#updates by WIPAT 2555-04-24
#updates by WIBOON 2556-07-10

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi

while true; do
    read -p "Confirm to start installation? (y/n)" yn
    case $yn in
        [Yy]* ) CONFIRM_INSTALL="yes"; break;;
        [Nn]* ) CONFIRM_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${CONFIRM_INSTALL}" = "no" ]; then
  exit 
fi

sudo apt-get update
sudo apt-get -y install apache2 php5 expect 
sudo apt-get -y install whois
sudo apt-get -y install apg

MY_DIR=$(pwd)
SRC_DIR="${MY_DIR}/trunk/"
DST_DIR="/"

find ${SRC_DIR} -type d| while read LINE ; do
  TARGET=$(echo ${LINE}|sed "s;${SRC_DIR};${DST_DIR};")
  if [ ! -d "${TARGET}" ] ; then
    mkdir ${TARGET}
  fi
done
find ${SRC_DIR} -type f| while read LINE ; do
  TARGET=$(echo ${LINE}|sed "s;${SRC_DIR};${DST_DIR};")
  if [ -e "${TARGET}" ] ; then
    if [ -z "$(diff -q ${LINE} ${TARGET})" ] ; then
      continue
    fi 
    INFO=$(ls -clQ --time-style=long-iso ${TARGET})
    CTIME=$(echo ${INFO}|awk '{ print $6"-"$7 }')
    NAME=$(echo "${TARGET}_${CTIME}")
    cp -v ${TARGET} ${NAME}
  fi
  cp -v ${LINE} ${TARGET}
done
sudo cp -f ${MY_DIR}/version.txt /root/psu-netdrive.version
sudo groupadd sftponly 
sudo mkdir -p /sftp 
sudo mkdir -p /sftp/home
sudo mkdir -p /sftp/share 
sudo chmod +t /sftp/share 
sudo groupadd member
sudo mkdir -p /sftp/share/member 
sudo chgrp -Rv member /sftp/share/member
sudo chmod  g+rws,o-rwx /sftp/share/member 
sudo gpasswd -a $(grep "1000:.*/home" /etc/passwd | cut -d: -f1) member
sudo chmod +x /var/www/myservice/check-shadow.sh 
sudo chmod +x /var/www/myservice/change-passwd.exp 
MYSUDO="www-data ALL= NOPASSWD: /var/www/myservice/check-shadow.sh, /var/www/myservice/change-passwd.exp"
MYFILE="/etc/sudoers"
if [ -z "$(grep "${MYSUDO}" ${MYFILE})" ] ; then
  echo "${MYSUDO}" >> ${MYFILE}
fi 
#
sudo touch /sftp/home/DO_NOT_UPLOAD_HERE.txt
sudo mkdir -p /var/www/noname
sudo mkdir -p /var/www/ishare
MYINSTALL="<Directory /var/www/noname/>"
MYFILE="/etc/apache2/sites-available/default"
if [ -z "$(grep "${MYINSTALL}" ${MYFILE})" ] ; then
  sudo sed -i '/^<\/VirtualHost>/i\
        <Directory /var/www/noname/>\
                Options FollowSymLinks MultiViews\
                AllowOverride None\
                Order allow,deny\
                allow from all\
        </Directory>' ${MYFILE}
fi
sudo reload ssh
sudo /etc/init.d/apache2 restart

if [ ! -z "$(grep "/home" /etc/fstab)" ]; then
   FOUND_FSTAB_HOME="yes"
else
   FOUND_FSTAB_HOME="no"
fi

if [ "${FOUND_FSTAB_HOME}" = "yes" ]; then
while true; do
    echo "Found! partition /home in /etc/fstab"
    echo "Do you wish to use /home or / for net-drive users? (y/n) "
    read -p "y=/home  n=/(default) :" yn
    case $yn in
        [Yy]* ) USE_HOME_PAR="yes"; break;;
        [Nn]* ) USE_HOME_PAR="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${USE_HOME_PAR}" = "yes" ]; then
    sudo sh move-sftp-to-home.sh
else
    echo "copy move-sftp-to-home.sh to /root for later use /home for net-drive users"
    sudo cp move-sftp-to-home.sh /root
fi
fi

echo "................"
echo "Next, option 1/4"
echo "To install anonymous ftp server (vsftpd) and make link to /sftp/ftp/pub."
while true; do
    echo "Do you wish to install anonymous ftp server? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) VSFTPD_INSTALL="yes"; break;;
        [Nn]* ) VSFTPD_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${VSFTPD_INSTALL}" = "yes" ]; then
    sudo sh install-psu-netdrive-2-anonymous.sh 
else
    echo "copy install-psu-netdrive-2-anonymous.sh to /root for later install"
    sudo cp install-psu-netdrive-2-anonymous.sh /root
fi

echo "................"
echo "Next, option 2/4"
echo "To install shorewall and fail2ban to protect from hacker."
echo "( shorewall default firewall interface is eth0 )"
echo "( fail2ban default protect your tcp port 22(ssh) )"
while true; do
    echo "Do you wish to install shorewall and fail2ban? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) SHOREWALL_INSTALL="yes"; break;;
        [Nn]* ) SHOREWALL_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${SHOREWALL_INSTALL}" = "yes" ]; then
    sudo sh install-shorewall-fail2ban.sh
else
    echo "copy install-shorewall-fail2ban.sh to /root for later install"
    sudo cp install-shorewall-fail2ban.sh /root
fi

echo "................"
echo "Next, option 3/4"
echo "To install disk quota system for PSU-netdrive's partition."
while true; do
    echo "Do you wish to install disk quota system? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) QUOTA_INSTALL="yes"; break;;
        [Nn]* ) QUOTA_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${QUOTA_INSTALL}" = "yes" ]; then
    sudo sh install-quota.sh
else
    echo "copy install-quota.sh to /root for later install"
    sudo cp install-quota.sh /root
fi

echo "................"
echo "Next, option 4/4"
echo "To install libpam-radius-auth library, then SFTP will also work with FreeRADIUS for your existing username database i.e. ldap or sql." 

while true; do
    echo "Do you wish to install libpam-radius-auth? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) LIBPAMRADIUS_INSTALL="yes"; break;;
        [Nn]* ) LIBPAMRADIUS_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${LIBPAMRADIUS_INSTALL}" = "yes" ]; then
    sudo sh install-pam-radius.sh
    if [ ! -f /etc/freeradius/clients.conf ] ; then
      echo "copy install-pam-radius.sh to /root for later install"
      sudo cp install-pam-radius.sh /root
    fi
else
    echo "copy install-pam-radius.sh to /root for later install"
    sudo cp install-pam-radius.sh /root
fi
echo "Finished."
