#!/bin/bash

# updated by WIBOON 2556-04-17

exitusage()
{
  echo "usage: sudo sh $0 username groupname"
  exit 
}

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  echo "need username"
  exitusage 
fi
if [ -z "$2" ] ; then
  echo "need groupname"
  exitusage 
fi
if [ -z "$(getent passwd $1)" ] ; then
  echo "username $1 does not exist"
  exit
fi
if [ -z "$(getent group $2)" ] ; then
  echo "group $2 does not exist"
  exit
fi
MYUSER=$1
MYGROUP=$2
sudo gpasswd -a ${MYUSER} ${MYGROUP}
